/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pv168.preferencesdemo;

import java.io.IOException;
import java.util.prefs.BackingStoreException;
import java.util.prefs.Preferences;

/**
 *
 * @author tomp
 */
public class PreferencesDemo {

    public void setUserPreferences() {

        // This will define a node for user-related prefs
        // in which the preferences can be stored
        Preferences userPrefs = Preferences.userNodeForPackage(
                // using this package as identifier for the root of 
                // the subtree for preferences of this program
                this.getClass());

        String directory = "/Users/tomp/Desktop/Vyuka/";
        String color = "black";
        int imageWidth = 1024;
        boolean autoSaveOnClose = true;

        // now set the values
        userPrefs.put("directory", directory);
        userPrefs.put("color", color);
        userPrefs.putInt("imageWidth", imageWidth);
        userPrefs.putBoolean("autoSaveOnClose", autoSaveOnClose);
    }

    public void setApplicationPreferences() {
        // This will define a node for application-wide prefs
        // in which the preferences can be stored
        Preferences appPrefs = Preferences.systemNodeForPackage(
                // using this package name as identifier for the root of 
                // the subtree for preferences of this program
                this.getClass());

        String pluginDirectory = "/Users/tomp/Desktop/Vyuka/plugins";

        // now set the values
        appPrefs.put("pluginDirectory", pluginDirectory);

        appPrefs.put("defaultColor", "white");
        appPrefs.putInt("defaultImageWidth", 1920);
        appPrefs.putBoolean("defaultAutoSaveOnClose", false);
    }

    public void usePreferences() {

        Preferences appPrefs = Preferences.systemNodeForPackage(
                this.getClass());

        Preferences userPrefs = Preferences.userNodeForPackage(
                this.getClass());

        String color = userPrefs.get("color", appPrefs.get("defaultColor", "black"));

        System.out.println("color used=" + color);
    }

    public void writeUserPreferences() throws BackingStoreException, IOException {

        Preferences userPrefs = Preferences.userNodeForPackage(
                this.getClass());
        
        userPrefs.exportSubtree(System.out);
    }
    
    public void runDemo() throws BackingStoreException, IOException {
        
        // sets the user-specific settings
        setUserPreferences();
        
        // sets the global preferences, ie. for the whole app.
        setApplicationPreferences();
        
        // user preferences are now used as primary source 
        // of a setting. If the key is not set, we use application-wide
        // preferences
        usePreferences();
        // normally, this is not needed.
        // One may need it for exchange of preferences 
        // among (independent) systems or more different apps.
        writeUserPreferences();
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws BackingStoreException, IOException {
        
        new PreferencesDemo().runDemo();
        
    }
}
